RaidIconBarData = {};

RaidIconBarData.targetonly = nil;

-- Bindings
BINDING_HEADER_RIBHEADER = "RaidIconBar";
BINDING_NAME_RIBSNAP = "MouseSnap";

def_posx = 0;
def_posy = 0;

alwaysVisible = 0;

-- functions
function RaidIconBar_OnLoad()

 	DEFAULT_CHAT_FRAME:AddMessage("|c333399ffNirriti's |rRaidIconBar loaded.", 1.0, 1.0, 1.0, 1, 10);

	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("PARTY_MEMBERS_CHANGED");
	
	this:RegisterEvent("PLAYER_TARGET_CHANGED");

	SLASH_RAIDICONBAR1 = "/raidiconbar";
  	SLASH_RAIDICONBAR2 = "/rib";
  	SlashCmdList["RAIDICONBAR"] = function(msg)
		RaidIconBar_SlashCommandHandler(msg);
	end
end

function RaidIconBar_SlashCommandHandler(msg)
	if (msg == "reload") then
	 	ReloadUI();
	end
	
	if (msg == "show") then
	 	alwaysVisible = 1;
	 	RaidIconBar_OnEvent();
	elseif (msg == "hide") then
	 	alwaysVisible = 0;
	 	RaidIconBar_OnEvent();
	elseif (msg == "always") then
	 	RaidIconBarData.targetonly = nil;
	elseif (msg == "targetonly") then
	 	RaidIconBarData.targetonly = 1;
	end
	
	RaidIconBar_CheckVisibility();
end

function RaidIconBar_OnClick(self, button, down)
	if (button == "LeftButton") then
   		id = this:GetID();
   		SetRaidTarget("target",id);
	elseif (button == "RightButton") then
		SetRaidTarget("target",0);
	end
end

function RaidIconBar_OnEvent(event)
	if (event == "PLAYER_ENTERING_WORLD" or
	    event == "PARTY_MEMBERS_CHANGED" or
	    event == "PLAYER_TARGET_CHANGED") then
	    RaidIconBar_CheckVisibility();
	end
end

function RaidIconBar_CheckVisibility()
	local frame = getglobal("RaidIconBarFrame");
	
	if (RaidIconBarData.targetonly == 1 and UnitExists("target") == nil and alwaysVisible == 0) then
		frame:Hide();
		return;
	end
	
	if (alwaysVisible == 0) then
   		if (frame) then
			if( GetNumPartyMembers() > 0 ) then
      			frame:Show();
   			else
      			frame:Hide();
   			end
   			
   			if (GetNumRaidMembers() > 0) then
   				if ( IsRaidOfficer() or IsRaidLeader() ) then
      		        frame:Show();
     			else
     				frame:Hide();
    			end
   			end
   		end
   	else
   		frame:Show();
  	end
end

function RaidIconBar_SnapDown()
	local frame = getglobal("RaidIconBarFrame");
	
	def_posx = frame:GetLeft();
	def_posy = frame:GetBottom();
	
	x, y = GetCursorPosition();
	
	_, _, w, h = UIParent:GetRect();
	
	dh = 768;
	dw = w/h*dh;
	
	x = x / dw * w;	
	y = y / dh * h;
	
	local frame = getglobal("RaidIconBarFrame");
	frame:ClearAllPoints();
	frame:SetPoint("CENTER", UIParent, "BOTTOMLEFT", x, y);
end

function RaidIconBar_SnapUp()
	local frame = getglobal("RaidIconBarFrame");
	frame:ClearAllPoints();
	frame:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", def_posx, def_posy);
end